#include <stdio.h>

#define MAX_N	20
#define MAX_M	10

int	m, n;
float	x[(MAX_M+1)*MAX_N], y[(MAX_M+1)*MAX_N], z[(MAX_M+1)*MAX_N];
float	vx, vy, vz;
int	p[MAX_M*MAX_N+2][MAX_N];


int ispitivanje (float vx, float vy, float vz)
{
	int i, t1, t2, t3;
	float A, B, C, D;

	for (i=0; i < m*n+2; i++)
	{
		t1 = p[i][0];
		t2 = p[i][1];
		t3 = p[i][2];
		
		A = (y[t2] - y[t1]) * (z[t3] - z[t1]) - (z[t2] - z[t1]) * (y[t3] - y[t1]);
		B = - (x[t2] - x[t1]) * (z[t3] - z[t1]) + (z[t2] - z[t1]) * (x[t3] - x[t1]);
		C = (x[t2] - x[t1]) * (y[t3] - y[t1]) - (y[t2] - y[t1]) * (x[t3] - x[t1]);
		D = - x[t1] * A - y[t1] * B - z[t1] * C;

		if (A * vx + B * vy + C * vz + D < 0)
			return -1;
	}
	return +1;
}


int main (int argc, char *argv[])
{
	FILE *f;
	int i, j;
	char *datoteka = "ulaz.txt";

	if (argc == 2)
		datoteka = argv[1];
	f = fopen (datoteka, "r");
	if (!f) {
		printf ("Datoteka %s ne postoji!?\n", datoteka);
		return (1);
	}

	fscanf (f, "%d %d", &n, &m);
	for (i=0; i < (m+1)*n  &&  fscanf (f, "%f %f %f", &x[i], &y[i], &z[i]) == 3; i++);
	if (n < 3  ||  m < 1  ||  i < n*m  ||  fscanf (f, "%f %f %f", &vx, &vy, &vz) != 3) {
		printf ("Molim osigurajte da je datoteka u ispravnom formatu.\n", datoteka);
		return (1);
	}

	for (i=0; i<n; i++) {
		p[0][i] = i;
		p[m*n+1][n-1-i] = m*n + i;
	}

	for (j=0; j<m; j++) {
		for (i=0; i<n; i++) {
			p[j*n+i+1][0] = j*n + (i+1) % n;
			p[j*n+i+1][1] = j*n + i;
			p[j*n+i+1][2] = (j+1)*n + i;
			p[j*n+i+1][3] = (j+1)*n + (i+1) % n;
		}
	}

	i = ispitivanje (vx, vy, vz);
	printf ("Zadana tocka (%.2f, %.2f, %.2f) je %s zadanog tijela.\n", vx, vy, vz, i > 0 ? "unutar" : "izvan");

	getchar ();
	return (0);
}